"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sendTag = exports.event_15_00 = exports.event_13_00 = exports.event_11_00 = exports.event_10_00 = exports.event_09_00 = exports.event_08_02 = exports.event_08_01 = exports.event_07_01 = exports.event_06_00 = exports.event_05_01 = exports.event_05_00 = exports.event_04_01 = exports.event_04_00 = exports.event_03_01 = exports.event_03_00 = exports.event_02_01 = exports.event_02_00 = exports.event_01_04 = exports.event_01_03 = void 0;
var _utils = require("../../utils");
const sendTag = (gtmId, dataLayer) => {
  if (!gtmId) return;
  window.dataLayer = window.dataLayer || [];
  window.dataLayer.push({
    event: dataLayer.event_name,
    eventProps: {
      dataLayer
    }
  });
};

// Onboarding
exports.sendTag = sendTag;
const event_01_03 = function event_01_03() {
  let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  const isValid = state && state.length > 0;
  const step_status = isValid ? "success" : "fail";
  const error_message = isValid ? null : "state not provided";
  const payload = eventBase({
    identifier: "01.03",
    event_name: "login_funnel",
    section: "ubicacion",
    button_name: "Continuar",
    funnel: createFunnelPayload({
      step: "3",
      action: "ubicación",
      detail: state,
      step_status,
      error_message
    })
  });
  return payload;
};
exports.event_01_03 = event_01_03;
const event_01_04 = () => {
  const payload = eventBase({
    identifier: "01.04",
    event_name: "login_funnel",
    section: "onboarding",
    button_name: "Continuar",
    funnel: createFunnelPayload({
      step: "4",
      action: "terminos_condiciones",
      step_status: "success"
    })
  });
  return payload;
};

// Promotions
exports.event_01_04 = event_01_04;
const event_02_00 = (card, origin, type) => {
  const payload = eventBase({
    identifier: "02.00",
    event_name: "promotion_selected",
    section: "promociones",
    button_name: "Click en una promoción",
    benefits: createBenefit(card, origin, type)
  });
  return payload;
};
exports.event_02_00 = event_02_00;
const event_02_01 = (card, origin, type) => {
  const payload = eventBase({
    identifier: "02.01",
    event_name: "promotion_detail",
    section: "detalle de promocion",
    button_name: "Click en detalle de promoción",
    general: createGeneral({}, true),
    benefits: createBenefit(card, origin, type)
  });
  return payload;
};

// Stamps
exports.event_02_01 = event_02_01;
const event_03_00 = (card, origin, type) => {
  const payload = eventBase({
    identifier: "03.00",
    event_name: "punchcard_selected",
    section: "sellos",
    button_name: "Click en un sello",
    benefits: createBenefit(card, origin, type)
  });
  return payload;
};
exports.event_03_00 = event_03_00;
const event_03_01 = (card, origin, type) => {
  const payload = eventBase({
    identifier: "03.01",
    event_name: "punchcard_detail",
    section: "detalle de sello",
    button_name: "Click en detalle de sello",
    general: createGeneral({}, true),
    benefits: createBenefit(card, origin, type)
  });
  return payload;
};

// Rewards
exports.event_03_01 = event_03_01;
const event_04_00 = (card, origin, type) => {
  const payload = eventBase({
    identifier: "04.00",
    event_name: "reward_selected",
    section: "recompensas",
    button_name: "Click en una recompensa",
    benefits: createBenefit(card, origin, type)
  });
  return payload;
};
exports.event_04_00 = event_04_00;
const event_04_01 = (card, origin, type) => {
  const payload = eventBase({
    identifier: "04.01",
    event_name: "reward_detail",
    section: "detalle de recompensa",
    button_name: "Click en detalle de recompensa",
    general: createGeneral({}, true),
    benefits: createBenefit(card, origin, type)
  });
  return payload;
};

// Extra Points
exports.event_04_01 = event_04_01;
const event_05_00 = (card, origin, type) => {
  const payload = eventBase({
    identifier: "05.00",
    event_name: "extra_points_selected",
    section: "puntos adicionales",
    button_name: "Click en unos puntos adicionales",
    benefits: createBenefit(card, origin, type)
  });
  return payload;
};
exports.event_05_00 = event_05_00;
const event_05_01 = (card, origin, type) => {
  const payload = eventBase({
    identifier: "05.01",
    event_name: "extra_points_detail",
    section: "detalle de puntos adicionales",
    button_name: "Click en detalle de puntos adicionales",
    general: createGeneral({}, true),
    benefits: createBenefit(card, origin, type)
  });
  return payload;
};

// My Account
exports.event_05_01 = event_05_01;
const event_06_00 = function event_06_00() {
  var _question$section, _question$question, _question$id, _question$position;
  let question = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  let e = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  const payload = eventBase({
    identifier: "06.00",
    event_name: "faq_consulted",
    section: "mi cuenta (ayuda)",
    button_name: "Click en alguna pregunta",
    faq: {
      faq_section: (_question$section = question.section) !== null && _question$section !== void 0 ? _question$section : e,
      faq_question: (_question$question = question.question) !== null && _question$question !== void 0 ? _question$question : e,
      faq_identifier: (_question$id = question.id) !== null && _question$id !== void 0 ? _question$id : e,
      position: (_question$position = question.position) !== null && _question$position !== void 0 ? _question$position : e
    }
  });
  return payload;
};
exports.event_06_00 = event_06_00;
const event_07_01 = () => {
  const payload = eventBase({
    identifier: "07.01",
    event_name: "communication",
    section: "mi cuenta (ayuda)",
    button_name: "Click en teléfono",
    clicks: createClickDetail({
      screen: "mi_cuenta_ayuda",
      section: "header",
      clicked: "telefono"
    })
  });
  return payload;
};
exports.event_07_01 = event_07_01;
const event_13_00 = () => {
  const payload = eventBase({
    identifier: "13.00",
    event_name: "movements",
    section: "mi cuenta (movimientos)",
    button_name: "Click en Movimientos de tus puntos",
    clicks: createClickDetail({
      screen: "mi_cuenta_movimientos",
      section: "header",
      clicked: "Movimiento_de_tus_puntos"
    })
  });
  return payload;
};

// Legals
exports.event_13_00 = event_13_00;
const event_08_01 = screen => {
  const payload = eventBase({
    identifier: "08.01",
    event_name: "legal_consulted",
    section: "footer",
    button_name: "Click en términos y condiciones",
    clicks: createClickDetail({
      screen,
      section: "footer",
      clicked: "terminos_y_condiciones"
    })
  });
  return payload;
};
exports.event_08_01 = event_08_01;
const event_08_02 = screen => {
  const payload = eventBase({
    identifier: "08.02",
    event_name: "legal_consulted",
    section: "footer",
    button_name: "Click en aviso de privacidad",
    clicks: createClickDetail({
      screen,
      section: "footer",
      clicked: "aviso_de_privacidad"
    })
  });
  return payload;
};

// Page change
exports.event_08_02 = event_08_02;
const event_09_00 = page => {
  const payload = eventBase({
    identifier: "09.00",
    event_name: "pageview"
  });
  return payload;
};

// Banners
exports.event_09_00 = event_09_00;
const event_10_00 = () => {
  const payload = eventBase({
    identifier: "10.00",
    event_name: "banner_dashboard",
    section: "dashboard",
    button_name: "Click en banner",
    clicks: createClickDetail({
      screen: "dashboard",
      section: "banners",
      clicked: "banner"
    })
  });
  return payload;
};
exports.event_10_00 = event_10_00;
const event_11_00 = screen => {
  const payload = eventBase({
    identifier: "11.00",
    event_name: "banner_beneficios",
    section: "beneficios",
    button_name: "Click en banner",
    clicks: createClickDetail({
      screen,
      section: "beneficios",
      clicked: "banner_beneficios"
    })
  });
  return payload;
};

// Request error
exports.event_11_00 = event_11_00;
const event_15_00 = screen => {
  const payload = eventBase({
    identifier: "15.00",
    event_name: "system_error",
    section: "Error",
    button_name: "Volver al inicio",
    clicks: createClickDetail({
      screen,
      section: "error",
      clicked: "volver_al_inicio"
    })
  });
  return payload;
};
exports.event_15_00 = event_15_00;
const createGeneral = function createGeneral() {
  var _cxt$click_id, _cxt$user_id, _cxt$session_id, _cxt$hash_id, _cxt$device_id, _cxt$source, _cxt$medium, _cxt$campaign;
  let cxt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  let detail = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  let e = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  let res = {
    pwa_ally: "oxxo_premia",
    click_id: (_cxt$click_id = cxt.click_id) !== null && _cxt$click_id !== void 0 ? _cxt$click_id : e,
    user_id: (_cxt$user_id = cxt.user_id) !== null && _cxt$user_id !== void 0 ? _cxt$user_id : e,
    session_id: (_cxt$session_id = cxt.session_id) !== null && _cxt$session_id !== void 0 ? _cxt$session_id : e,
    hash_id: (_cxt$hash_id = cxt.hash_id) !== null && _cxt$hash_id !== void 0 ? _cxt$hash_id : e,
    device_type: (0, _utils.isPortable)() ? "mobile" : "desktop",
    timestamp: Date.now(),
    device_id: (_cxt$device_id = cxt.device_id) !== null && _cxt$device_id !== void 0 ? _cxt$device_id : e,
    source: (_cxt$source = cxt.source) !== null && _cxt$source !== void 0 ? _cxt$source : e,
    medium: (_cxt$medium = cxt.medium) !== null && _cxt$medium !== void 0 ? _cxt$medium : e,
    campaign: (_cxt$campaign = cxt.campaign) !== null && _cxt$campaign !== void 0 ? _cxt$campaign : e
  };
  if (detail) res.drop_down_clicked = "terminos_y_condiciones";
  return res;
};
const createBenefit = function createBenefit(card, origin, type) {
  var _card$sponsor_name, _card$sponsor_id, _card$product_id, _card$position;
  let e = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  return {
    benefit_name: card.title,
    benefit_type: type,
    benefit_id: card.id,
    ally: (_card$sponsor_name = card.sponsor_name) !== null && _card$sponsor_name !== void 0 ? _card$sponsor_name : e,
    ally_id: (_card$sponsor_id = card.sponsor_id) !== null && _card$sponsor_id !== void 0 ? _card$sponsor_id : e,
    product_id: (_card$product_id = card.product_id) !== null && _card$product_id !== void 0 ? _card$product_id : e,
    screen: origin,
    benefit_position: (_card$position = card.position) !== null && _card$position !== void 0 ? _card$position : e,
    benefit_page_number: 1,
    benefit_status: "launched",
    benefit_percentage_complete: drawableBalance(card.balance, card.required_balance, card.available_to_redeem)
  };
};
const drawableBalance = function drawableBalance() {
  let balance = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  let needed = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  let ready = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  const totalBalance = balance += ready ? ready * needed : 0;
  return "".concat(totalBalance, "/").concat(needed);
};
const createFunnelPayload = function createFunnelPayload() {
  var _funnel$step, _funnel$action, _funnel$detail, _funnel$step_status, _funnel$error_message;
  let funnel = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  let e = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  let res = {
    funnel_name: "login",
    funnel_step: (_funnel$step = funnel.step) !== null && _funnel$step !== void 0 ? _funnel$step : e,
    funnel_action: (_funnel$action = funnel.action) !== null && _funnel$action !== void 0 ? _funnel$action : e,
    funnel_detail: (_funnel$detail = funnel.detail) !== null && _funnel$detail !== void 0 ? _funnel$detail : e,
    funnel_step_status: (_funnel$step_status = funnel.step_status) !== null && _funnel$step_status !== void 0 ? _funnel$step_status : e,
    funnel_error_message: (_funnel$error_message = funnel.error_message) !== null && _funnel$error_message !== void 0 ? _funnel$error_message : e
  };
  return res;
};
const createClickDetail = function createClickDetail() {
  let cxt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  let e = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  const {
    screen = e,
    section = e,
    clicked = e
  } = cxt;
  return {
    screen,
    section,
    clicked
  };
};
const eventBase = _ref => {
  let {
    identifier = null,
    event_name = null,
    section = null,
    button_name = null,
    general = null,
    clicks = null,
    benefits = null,
    funnel = null,
    faq = null
  } = _ref;
  return {
    identifier,
    event_name,
    section,
    button_name,
    general: general !== null && general !== void 0 ? general : createGeneral(),
    clicks,
    benefits,
    funnel,
    faq
  };
};