"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CoalitionStampsProgressDetail = exports.CoalitionStampsProgress = void 0;
var _react = _interopRequireDefault(require("react"));
var _utils = require("./../../utils");
var _pngs = require("./pngs");
require("./CoalitionStampsProgress.scss");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const CoalitionStampsProgress = _ref => {
  let {
    used = 0,
    needed = 0,
    drawables = 5
  } = _ref;
  const draw = [];
  const limit = needed >= drawables ? drawables : needed;
  for (let i = 0; i < limit; i++) {
    const source = used >= needed ? _pngs.stamp_2 : i < used ? _pngs.stamp_1 : _pngs.stamp_0;
    draw.push( /*#__PURE__*/_react.default.createElement("span", {
      key: (0, _utils.makeId)(5),
      className: "bullet"
    }, /*#__PURE__*/_react.default.createElement("img", {
      src: source,
      alt: "stamp"
    })));
  }
  const remanent = needed - drawables;
  if (remanent <= 0) return draw;
  draw.push( /*#__PURE__*/_react.default.createElement("span", {
    key: (0, _utils.makeId)(5),
    className: "bullet"
  }, /*#__PURE__*/_react.default.createElement("label", {
    className: "simple-counter"
  }, "+".concat(remanent))));
  return draw;
};
exports.CoalitionStampsProgress = CoalitionStampsProgress;
const CoalitionStampsProgressDetail = _ref2 => {
  let {
    used = 0,
    needed = 0,
    drawables = 5
  } = _ref2;
  const draw = [];
  let filled = 0;
  let remanent = 0;
  let counter = 0;
  const fillBullets = (limit, src) => {
    for (let i = 0; i < limit; i++) {
      draw.push( /*#__PURE__*/_react.default.createElement("span", {
        key: (0, _utils.makeId)(5),
        className: "bullet"
      }, (0, _utils.getImg)(src, "stamp")));
    }
  };
  if (used > needed) {
    filled = drawables;
    counter = needed - drawables;
  } else if (needed > drawables) {
    remanent = needed - used;
    filled = drawables - remanent;
    counter = needed - remanent - filled;
  } else if (needed < drawables) {
    filled = used;
    remanent = needed - filled;
  } else {
    filled = used;
    remanent = drawables - filled;
  }
  if (counter) {
    const src = used >= needed ? _pngs.stampBig_4 : _pngs.stampBig_3;
    draw.push( /*#__PURE__*/_react.default.createElement("span", {
      key: (0, _utils.makeId)(5),
      className: "bullet-counter",
      style: {
        backgroundImage: "url(".concat(src, ")")
      }
    }, /*#__PURE__*/_react.default.createElement("label", null, "+".concat(counter))));
  }
  fillBullets(filled, used >= needed ? _pngs.stampBig_2 : _pngs.stampBig_1);
  fillBullets(remanent, _pngs.stampBig_0);
  return draw;
};
exports.CoalitionStampsProgressDetail = CoalitionStampsProgressDetail;