"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UnauthorizedPage = exports.NotFoundPage = exports.GenericPage = void 0;
require("core-js/modules/es.symbol.description.js");
var _react = _interopRequireDefault(require("react"));
var _pngs = require("../pngs");
var _utils = require("../utils");
var _CoalitionGtm = require("../components/CoalitionGtm");
var _components = require("../components");
require("./Pages.scss");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const NotFoundPage = _ref => {
  let {
    gtmId,
    pathToGo
  } = _ref;
  (0, _CoalitionGtm.sendTag)(gtmId, (0, _CoalitionGtm.event_15_00)("not_found"));
  return /*#__PURE__*/_react.default.createElement(ErrorPage, {
    title: "Error 404",
    description: "No encontramos la página que buscas, por favor regresa a nuestra página principal",
    buttonClicked: pathToGo
  });
};
exports.NotFoundPage = NotFoundPage;
const UnauthorizedPage = _ref2 => {
  let {
    gtmId
  } = _ref2;
  (0, _CoalitionGtm.sendTag)(gtmId, (0, _CoalitionGtm.event_15_00)("unauthorized"));
  return /*#__PURE__*/_react.default.createElement(ErrorPage, {
    title: "Error 401",
    description: "Necesitas Iniciar sesión para acceder a este contenido"
  });
};
exports.UnauthorizedPage = UnauthorizedPage;
const ErrorPage = _ref3 => {
  let {
    title,
    description,
    buttonClicked
  } = _ref3;
  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_components.EmptyBlock, {
    title: title,
    description: description,
    emptyState: _pngs.not_found
  }, buttonClicked ? /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
    label: "Volver al Inicio",
    klass: "coalition-button-go-dashboard",
    onClickEvent: buttonClicked
  }) : null));
};
const GenericPage = _ref4 => {
  let {
    title,
    children,
    buttonClicked
  } = _ref4;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "generic-page"
  }, /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
    label: title,
    klass: "nav-button",
    onClickEvent: buttonClicked
  }, (0, _utils.getImg)(_pngs.chevron_left, "back-icon")), children ? /*#__PURE__*/_react.default.createElement("pre", {
    className: "content"
  }, children) : /*#__PURE__*/_react.default.createElement(_components.CoalitionSpinner, null)));
};
exports.GenericPage = GenericPage;