"use strict";

require("core-js/modules/es.object.assign.js");
require("core-js/modules/es.weak-map.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MovementsPage = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
var _react = _interopRequireWildcard(require("react"));
var _utils = require("../utils");
var _pngs = require("../pngs");
var _components = require("../components");
var _CoalitionGtm = require("../components/CoalitionGtm/CoalitionGtm");
require("./Pages.scss");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const MovementsPage = _ref => {
  let {
    movements = [],
    gtmId,
    buttonClicked
  } = _ref;
  const [content, setContent] = (0, _react.useState)( /*#__PURE__*/_react.default.createElement("div", {
    className: "landing-message"
  }, /*#__PURE__*/_react.default.createElement(_components.EmptyBlock, {
    title: "Movimientos de tus puntos",
    description: "Comienza a usar tu programa de lealtad para ganar puntos",
    emptyState: _pngs.empty_movements
  })));
  (0, _react.useEffect)(() => {
    const buildMovements = () => {
      (0, _CoalitionGtm.sendTag)(gtmId, (0, _CoalitionGtm.event_13_00)());
      const movsToDrawFiltered = movements.filter(mov => mov.data.length > 0);
      if (!movsToDrawFiltered || movsToDrawFiltered.length === 0) return;
      const movsAsHtml = movsToDrawFiltered.map((movement, k) => /*#__PURE__*/_react.default.createElement(MovementsCard, _extends({
        key: k
      }, movement)));
      setContent(movsAsHtml);
    };
    buildMovements();
  }, [movements, gtmId]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "movements-page"
  }, /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
    label: "Movimientos de tus puntos",
    klass: "nav-button",
    onClickEvent: buttonClicked
  }, (0, _utils.getImg)(_pngs.chevron_left, "back-icon")), content));
};
exports.MovementsPage = MovementsPage;
const MovementsCard = _ref2 => {
  let {
    title,
    data
  } = _ref2;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "movement-card"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "date"
  }, Titlelize(title)), data.map((info, i) => /*#__PURE__*/_react.default.createElement(MovementRow, _extends({
    key: i
  }, info))));
};
const MovementRow = _ref3 => {
  let {
    sponsor_name,
    brand_image,
    bits,
    is_accrual,
    transaction_date
  } = _ref3;
  const formattedDate = new Date(transaction_date).toLocaleDateString("es-mx", {
    weekday: "long",
    day: "numeric"
  });
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "movement-container"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "container-logo"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "logo"
  }, (0, _utils.getImg)(brand_image))), /*#__PURE__*/_react.default.createElement("div", {
    className: "container-description"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "description"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "title"
  }, sponsor_name), /*#__PURE__*/_react.default.createElement("div", {
    className: "detail"
  }, Titlelize(formattedDate)))), /*#__PURE__*/_react.default.createElement("div", {
    className: "container-ammount"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "ammount"
  }, /*#__PURE__*/_react.default.createElement("label", null, is_accrual ? "+ " : "- ", /*#__PURE__*/_react.default.createElement(_utils.MakePriceWithCents, {
    bits: bits
  }))))));
};
const Titlelize = str => str.charAt(0).toUpperCase() + str.slice(1);