"use strict";

require("core-js/modules/es.weak-map.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RewardsPage = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.symbol.description.js");
var _react = _interopRequireWildcard(require("react"));
var _components = require("../components");
var _utils = require("../utils");
var _pngs = require("../pngs");
require("./../components/CoalitionBlocks/EmptyBlock.scss");
require("./Pages.scss");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
class RewardsPage extends _react.Component {
  constructor() {
    super(...arguments);
    _defineProperty(this, "state", {
      isShown: false,
      activeCard: null
    });
    _defineProperty(this, "toggleModal", cardId => {
      this.setState({
        isShown: Boolean(cardId),
        activeCard: this.getCardDetail(cardId)
      });
      this.toggleScrollLock();
    });
    // Allows to close modal with click out of modal
    _defineProperty(this, "onClickOutside", e => this.modal && this.modal.contains(e.target) ? null : this.toggleModal());
    // Allows to close modal with 'Esc'
    _defineProperty(this, "onKeyDown", e => e.keyCode === 27 ? this.toggleModal() : null);
    // Prevents double scroll bar
    _defineProperty(this, "toggleScrollLock", () => document.querySelector("html").classList.toggle("modal-scroll-lock"));
    _defineProperty(this, "getCardDetail", cardId => this.props.rewards.find(stamp => stamp.id === cardId));
    _defineProperty(this, "PageButton", () => /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
      label: "Volver al Inicio",
      klass: "coalition-button-go-dashboard",
      onClickEvent: this.props.buttonClicked
    }));
    _defineProperty(this, "NavButton", () => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
      label: this.title,
      klass: "nav-button",
      onClickEvent: this.props.buttonClicked
    }, (0, _utils.getImg)(_pngs.chevron_left, "back-icon"))));
    _defineProperty(this, "emptyTitle", "Suma al comprar");
    _defineProperty(this, "emptyDesc", "Muy pronto podrás acumular tus compras y obtener recompensas de regalo");
    _defineProperty(this, "title", "Recompensas");
    _defineProperty(this, "modalTitle", "Todo sobre tus ".concat(this.title));
    _defineProperty(this, "filledDesc", "Llega a la meta al acumular tus compras y obtén recompensas de regalo");
  }
  render() {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !this.props.rewards || this.props.rewards.length === 0 ? /*#__PURE__*/_react.default.createElement(_components.EmptyBlock, {
      title: this.emptyTitle,
      description: this.emptyDesc,
      emptyState: _pngs.empty_rewards,
      children: /*#__PURE__*/_react.default.createElement(this.PageButton, null)
    }) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
      className: "carousel-cards"
    }, /*#__PURE__*/_react.default.createElement(this.NavButton, null), /*#__PURE__*/_react.default.createElement("div", {
      className: "title"
    }, this.emptyTitle), /*#__PURE__*/_react.default.createElement("div", {
      className: "description"
    }, this.filledDesc), this.props.rewards.map((i, k) => /*#__PURE__*/_react.default.createElement(_components.CoalitionCardReward, {
      key: k,
      id: i.id,
      product: i.image,
      title: i.title,
      used: i.balance,
      needed: i.required_balance,
      availableToRedeem: i.available_to_redeem,
      showModal: cardId => this.toggleModal(cardId)
    }))), this.state.isShown ? /*#__PURE__*/_react.default.createElement(_components.CoalitionModal, {
      modalRef: n => this.modal = n,
      closeModal: () => this.toggleModal(),
      onKeyDown: this.onKeyDown,
      onClickOutside: this.onClickOutside,
      title: "Todo sobre la recompensa",
      footer: this.state.activeCard.valid_until
    }, /*#__PURE__*/_react.default.createElement(_components.CoalitionCardRewardDetail, {
      card: this.state.activeCard,
      origin: "promociones",
      gtmId: this.props.gtmId
    })) : null));
  }
}
exports.RewardsPage = RewardsPage;